#!/bin/bash
# All paths are relative to the BUILD subdirectory,
# not where makepno.sh resides.
#If you create all your projects one level below the PARM
#directory, you'll only have to change SDKBASE and PEALMAIN
#and PROJECTMAIN variables, along with the stuff in pealexample.def.
SDKBASE="/PalmDev/sdk-5r3/include"
PROJECTDIR=".."
PROJECTMAIN="$PROJECTDIR/main.c"
PARMMAIN="../.."
PEALMAIN="/PalmDev/peal"
PEALARM="$PEALMAIN/arm"

INCLUDESDK=""
INCLUDESDK="$INCLUDESDK -I $SDKBASE/"
INCLUDESDK="$INCLUDESDK -I $SDKBASE/Extensions/"
INCLUDESDK="$INCLUDESDK -I $SDKBASE/Extensions/Bluetooth/"
INCLUDESDK="$INCLUDESDK -I $SDKBASE/Extensions/ExpansionMgr/"
INCLUDESDK="$INCLUDESDK -I $SDKBASE/68k/"
INCLUDESDK="$INCLUDESDK -I $SDKBASE/68k/libraries/"
INCLUDESDK="$INCLUDESDK -I $SDKBASE/68k/system/"
INCLUDESDK="$INCLUDESDK -I $SDKBASE/common/"
INCLUDESDK="$INCLUDESDK -I $SDKBASE/common/system/"
INCLUDESDK="$INCLUDESDK -I $SDKBASE/Core/"
INCLUDESDK="$INCLUDESDK -I $SDKBASE/Core/Hardware/"
INCLUDESDK="$INCLUDESDK -I $SDKBASE/Core/UI/"
INCLUDESDK="$INCLUDESDK -I $SDKBASE/Core/System/"
INCLUDESDK="$INCLUDESDK -I $SDKBASE/Core/System/Unix/"
INCLUDESDK="$INCLUDESDK -I $SDKBASE/Core/System/Dynamic/"
INCLUDESDK="$INCLUDESDK -I $SDKBASE/Libraries/"
INCLUDESDK="$INCLUDESDK -I $SDKBASE/Libraries/PalmOSGlue/"
INCLUDESDK="$INCLUDESDK -I $SDKBASE/System/"
INCLUDESDK="$INCLUDESDK -I $PROJECTDIR/"
INCLUDESDK="$INCLUDESDK -I $PARMMAIN/"
INCLUDESDK="$INCLUDESDK -I $PEALMAIN/"
INCLUDESDK="$INCLUDESDK -I $PEALMAIN/m68k/"
INCLUDESDK="$INCLUDESDK -I $PEALARM/"

ARMGCCOPTS="-fPIC -Os -Wl,--split-by-file=60000 -DPALMOS -march=armv4t -msingle-pic-base -Wl,--emit-relocs -nostartfiles -Werror"

cd BUILD
arm-palmos-gcc $ARMGCCOPTS $INCLUDESDK $PARMMAIN/pnotest.c  $PROJECTMAIN -o armc03e8.bin
$PEALMAIN/postlink/peal-postlink -v -s 1000 -o armc.ro armc03e8.bin &> Peal1.log
$PEALMAIN/postlink/peal-postlink -v -o armc.unsplit armc03e8.bin &> Peal2.log

m68k-palmos-gcc -I $PEALMAIN -O2 $PARMMAIN/pnostub.c -o pnostub.o
build-prc -o ../out.prc $PROJECTDIR/pealexample.def pnostub.o armc.ro 
